##// END OF EJS Templates
correcting wrong logic while selecting architecture
Unknown -
r301:3721bfc9be50
parent child
Show More
@@ -1,766 +1,768
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 # Debian release
46 # Debian release
47 RELEASE=${RELEASE:=jessie}
47 RELEASE=${RELEASE:=jessie}
48
48
49 #Kernel Branch
49 #Kernel Branch
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
51
51
52 # URLs
52 # URLs
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59
59
60 # Build directories
60 # Build directories
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 BUILDDIR="${BASEDIR}/build"
62 BUILDDIR="${BASEDIR}/build"
63
63
64 # Prepare date string for default image file name
64 # Prepare date string for default image file name
65 DATE="$(date +%Y-%m-%d)"
65 DATE="$(date +%Y-%m-%d)"
66 if [ -z "$KERNEL_BRANCH" ] ; then
66 if [ -z "$KERNEL_BRANCH" ] ; then
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 else
68 else
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 fi
70 fi
71
71
72 # Chroot directories
72 # Chroot directories
73 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
74 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
75 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
76 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
77 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79
79
80 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82
82
83 # General settings
83 # General settings
84 SET_ARCH=${SET_ARCH}
84 SET_ARCH=${SET_ARCH}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
91
91
92 # Keyboard settings
92 # Keyboard settings
93 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97
97
98 # Network settings (DHCP)
98 # Network settings (DHCP)
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100
100
101 # Network settings (static)
101 # Network settings (static)
102 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
109
109
110 # APT settings
110 # APT settings
111 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113
113
114 # Feature settings
114 # Feature settings
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
127 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
130 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133
133
134 # SSH settings
134 # SSH settings
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140
140
141 # Advanced settings
141 # Advanced settings
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
154
154
155 # Kernel compilation settings
155 # Kernel compilation settings
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
164
164
165 # Kernel compilation from source directory settings
165 # Kernel compilation from source directory settings
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
170
170
171 # Reduce disk usage settings
171 # Reduce disk usage settings
172 REDUCE_APT=${REDUCE_APT:=true}
172 REDUCE_APT=${REDUCE_APT:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
175 REDUCE_VIM=${REDUCE_VIM:=false}
175 REDUCE_VIM=${REDUCE_VIM:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
180
180
181 # Encrypted filesystem settings
181 # Encrypted filesystem settings
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
187
187
188 # Chroot scripts directory
188 # Chroot scripts directory
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190
190
191 # Packages required in the chroot build environment
191 # Packages required in the chroot build environment
192 APT_INCLUDES=${APT_INCLUDES:=""}
192 APT_INCLUDES=${APT_INCLUDES:=""}
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
194
194
195 # Packages required for bootstrapping
195 # Packages required for bootstrapping
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
197 MISSING_PACKAGES=""
197 MISSING_PACKAGES=""
198
198
199 # Packages installed for c/c++ build environment in chroot (keep empty)
199 # Packages installed for c/c++ build environment in chroot (keep empty)
200 COMPILER_PACKAGES=""
200 COMPILER_PACKAGES=""
201
201
202 set +x
202 set +x
203
203
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 if [ -n "$SET_ARCH" ] ; then
205 if [ -n "$SET_ARCH" ] ; then
206 echo "Setting Architecture specific settings"
206 echo "Setting Architecture specific settings"
207 ##################################
207 ##################################
208 # 64 bit config
208 # 64 bit config
209 ##################################
209 ##################################
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
210 if [ "$SET_ARCH" = 64 ] ; then
211 echo "64 bit mode selected - Setting up enviroment"
211 echo "64 bit mode selected - Setting up enviroment"
212 # 64 bit depended settings
212 # 64 bit depended settings
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219
219
220 # RPI 3 serie specific settings
220 if ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]) ; then
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
221 # RPI 3 serie specific settings
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
222 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
223 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
223
224
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
226 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
226 else
227 else
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
228 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
228 exit 1
229 exit 1
230 fi
229 fi
231 fi
230
232
231 ##################################
233 ##################################
232 # 32 bit config
234 # 32 bit config
233 ##################################
235 ##################################
234 if [ "$SET_ARCH" = 32 ] ; then
236 if [ "$SET_ARCH" = 32 ] ; then
235 echo "32 bit mode selected - Setting up enviroment"
237 echo "32 bit mode selected - Setting up enviroment"
236 #General 32bit configuration
238 #General 32bit configuration
237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
239 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
240 KERNEL_ARCH=${KERNEL_ARCH:=arm}
239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
241 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
240
242
241 #Raspberry setting grouped by board compability
243 #Raspberry setting grouped by board compability
242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
244 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
245 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
246 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
247 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
248 RELEASE_ARCH=${RELEASE_ARCH:=armel}
247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
249 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
250 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
249 fi
251 fi
250 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
252 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
251 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
253 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
252 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
254 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
253 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
255 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
254 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
256 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
255 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
257 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
256 fi
258 fi
257
259
258 #Device specific configuration
260 #Device specific configuration
259 case "$RPI_MODEL" in
261 case "$RPI_MODEL" in
260 0)
262 0)
261 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
262 1)
264 1)
263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
264 1P)
266 1P)
265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
267 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
266 2)
268 2)
267 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
269 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
268 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
270 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
269 #Precompiled Kernel rpi2
271 #Precompiled Kernel rpi2
270 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
272 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
271 ;;
273 ;;
272 3)
274 3)
273 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
275 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
274 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
276 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
275 ;;
277 ;;
276 3P)
278 3P)
277 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
279 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
278 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
280 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
279 ;;
281 ;;
280 *)
282 *)
281 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
283 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
282 exit 1
284 exit 1
283 ;;
285 ;;
284 esac
286 esac
285 #end 32 bit
287 #end 32 bit
286 fi
288 fi
287 #SET_ARCH not set
289 #SET_ARCH not set
288 else
290 else
289 echo "error: Please set '32' or '64' as value for SET_ARCH"
291 echo "error: Please set '32' or '64' as value for SET_ARCH"
290 exit 1
292 exit 1
291 fi
293 fi
292
294
293 # Check if the internal wireless interface is supported by the RPi model
295 # Check if the internal wireless interface is supported by the RPi model
294 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
296 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
295 echo "error: The selected Raspberry Pi model has no internal wireless interface"
297 echo "error: The selected Raspberry Pi model has no internal wireless interface"
296 exit 1
298 exit 1
297 else
299 else
298 echo "Raspberry Pi model"
300 echo "Raspberry Pi model"
299 fi
301 fi
300
302
301 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
303 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
302 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
304 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
303 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
305 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
304 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
306 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
305 exit 1
307 exit 1
306 fi
308 fi
307 fi
309 fi
308
310
309 # Add libncurses5 to enable kernel menuconfig
311 # Add libncurses5 to enable kernel menuconfig
310 if [ "$KERNEL_MENUCONFIG" = true ] ; then
312 if [ "$KERNEL_MENUCONFIG" = true ] ; then
311 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
312 fi
314 fi
313
315
314 # Add ccache compiler cache for (faster) kernel cross (re)compilation
316 # Add ccache compiler cache for (faster) kernel cross (re)compilation
315 if [ "$KERNEL_CCACHE" = true ] ; then
317 if [ "$KERNEL_CCACHE" = true ] ; then
316 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
317 fi
319 fi
318
320
319 # Add cryptsetup package to enable filesystem encryption
321 # Add cryptsetup package to enable filesystem encryption
320 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
322 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
321 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
323 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
322 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
324 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
323
325
324 if [ -z "$CRYPTFS_PASSWORD" ] ; then
326 if [ -z "$CRYPTFS_PASSWORD" ] ; then
325 echo "error: no password defined (CRYPTFS_PASSWORD)!"
327 echo "error: no password defined (CRYPTFS_PASSWORD)!"
326 exit 1
328 exit 1
327 fi
329 fi
328 ENABLE_INITRAMFS=true
330 ENABLE_INITRAMFS=true
329 fi
331 fi
330
332
331 # Add initramfs generation tools
333 # Add initramfs generation tools
332 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
334 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
333 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
335 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
334 fi
336 fi
335
337
336 # Add device-tree-compiler required for building the U-Boot bootloader
338 # Add device-tree-compiler required for building the U-Boot bootloader
337 if [ "$ENABLE_UBOOT" = true ] ; then
339 if [ "$ENABLE_UBOOT" = true ] ; then
338 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
340 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
339 fi
341 fi
340
342
341 # Check if root SSH (v2) public key file exists
343 # Check if root SSH (v2) public key file exists
342 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
344 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
343 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
345 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
344 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
346 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
345 exit 1
347 exit 1
346 fi
348 fi
347 fi
349 fi
348
350
349 # Check if $USER_NAME SSH (v2) public key file exists
351 # Check if $USER_NAME SSH (v2) public key file exists
350 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
352 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
351 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
353 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
352 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
354 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
353 exit 1
355 exit 1
354 fi
356 fi
355 fi
357 fi
356
358
357 # Check if all required packages are installed on the build system
359 # Check if all required packages are installed on the build system
358 for package in $REQUIRED_PACKAGES ; do
360 for package in $REQUIRED_PACKAGES ; do
359 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
361 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
360 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
362 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
361 fi
363 fi
362 done
364 done
363
365
364 # If there are missing packages ask confirmation for install, or exit
366 # If there are missing packages ask confirmation for install, or exit
365 if [ -n "$MISSING_PACKAGES" ] ; then
367 if [ -n "$MISSING_PACKAGES" ] ; then
366 echo "the following packages needed by this script are not installed:"
368 echo "the following packages needed by this script are not installed:"
367 echo "$MISSING_PACKAGES"
369 echo "$MISSING_PACKAGES"
368
370
369 echo -n "\ndo you want to install the missing packages right now? [y/n] "
371 echo -n "\ndo you want to install the missing packages right now? [y/n] "
370 read confirm
372 read confirm
371 [ "$confirm" != "y" ] && exit 1
373 [ "$confirm" != "y" ] && exit 1
372
374
373 # Make sure all missing required packages are installed
375 # Make sure all missing required packages are installed
374 apt-get -qq -y install ${MISSING_PACKAGES}
376 apt-get -qq -y install ${MISSING_PACKAGES}
375 fi
377 fi
376
378
377 # Check if ./bootstrap.d directory exists
379 # Check if ./bootstrap.d directory exists
378 if [ ! -d "./bootstrap.d/" ] ; then
380 if [ ! -d "./bootstrap.d/" ] ; then
379 echo "error: './bootstrap.d' required directory not found!"
381 echo "error: './bootstrap.d' required directory not found!"
380 exit 1
382 exit 1
381 fi
383 fi
382
384
383 # Check if ./files directory exists
385 # Check if ./files directory exists
384 if [ ! -d "./files/" ] ; then
386 if [ ! -d "./files/" ] ; then
385 echo "error: './files' required directory not found!"
387 echo "error: './files' required directory not found!"
386 exit 1
388 exit 1
387 fi
389 fi
388
390
389 # Check if specified KERNELSRC_DIR directory exists
391 # Check if specified KERNELSRC_DIR directory exists
390 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
392 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
391 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
393 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
392 exit 1
394 exit 1
393 fi
395 fi
394
396
395 # Check if specified UBOOTSRC_DIR directory exists
397 # Check if specified UBOOTSRC_DIR directory exists
396 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
398 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
397 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
399 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
398 exit 1
400 exit 1
399 fi
401 fi
400
402
401 # Check if specified FBTURBOSRC_DIR directory exists
403 # Check if specified FBTURBOSRC_DIR directory exists
402 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
404 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
403 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
405 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
404 exit 1
406 exit 1
405 fi
407 fi
406
408
407 # Check if specified CHROOT_SCRIPTS directory exists
409 # Check if specified CHROOT_SCRIPTS directory exists
408 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
410 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
409 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
411 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
410 exit 1
412 exit 1
411 fi
413 fi
412
414
413 # Check if specified device mapping already exists (will be used by cryptsetup)
415 # Check if specified device mapping already exists (will be used by cryptsetup)
414 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
416 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
415 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
417 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
416 exit 1
418 exit 1
417 fi
419 fi
418
420
419 # Don't clobber an old build
421 # Don't clobber an old build
420 if [ -e "$BUILDDIR" ] ; then
422 if [ -e "$BUILDDIR" ] ; then
421 echo "error: directory ${BUILDDIR} already exists, not proceeding"
423 echo "error: directory ${BUILDDIR} already exists, not proceeding"
422 exit 1
424 exit 1
423 fi
425 fi
424
426
425 # Setup chroot directory
427 # Setup chroot directory
426 mkdir -p "${R}"
428 mkdir -p "${R}"
427
429
428 # Check if build directory has enough of free disk space >512MB
430 # Check if build directory has enough of free disk space >512MB
429 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
431 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
430 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
432 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
431 exit 1
433 exit 1
432 fi
434 fi
433
435
434 set -x
436 set -x
435
437
436 # Call "cleanup" function on various signals and errors
438 # Call "cleanup" function on various signals and errors
437 trap cleanup 0 1 2 3 6
439 trap cleanup 0 1 2 3 6
438
440
439 # Add required packages for the minbase installation
441 # Add required packages for the minbase installation
440 if [ "$ENABLE_MINBASE" = true ] ; then
442 if [ "$ENABLE_MINBASE" = true ] ; then
441 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
443 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
442 fi
444 fi
443
445
444 # Add required locales packages
446 # Add required locales packages
445 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
447 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
446 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
448 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
447 fi
449 fi
448
450
449 # Add parted package, required to get partprobe utility
451 # Add parted package, required to get partprobe utility
450 if [ "$EXPANDROOT" = true ] ; then
452 if [ "$EXPANDROOT" = true ] ; then
451 APT_INCLUDES="${APT_INCLUDES},parted"
453 APT_INCLUDES="${APT_INCLUDES},parted"
452 fi
454 fi
453
455
454 # Add dbus package, recommended if using systemd
456 # Add dbus package, recommended if using systemd
455 if [ "$ENABLE_DBUS" = true ] ; then
457 if [ "$ENABLE_DBUS" = true ] ; then
456 APT_INCLUDES="${APT_INCLUDES},dbus"
458 APT_INCLUDES="${APT_INCLUDES},dbus"
457 fi
459 fi
458
460
459 # Add iptables IPv4/IPv6 package
461 # Add iptables IPv4/IPv6 package
460 if [ "$ENABLE_IPTABLES" = true ] ; then
462 if [ "$ENABLE_IPTABLES" = true ] ; then
461 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
463 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
462 fi
464 fi
463
465
464 # Add openssh server package
466 # Add openssh server package
465 if [ "$ENABLE_SSHD" = true ] ; then
467 if [ "$ENABLE_SSHD" = true ] ; then
466 APT_INCLUDES="${APT_INCLUDES},openssh-server"
468 APT_INCLUDES="${APT_INCLUDES},openssh-server"
467 fi
469 fi
468
470
469 # Add alsa-utils package
471 # Add alsa-utils package
470 if [ "$ENABLE_SOUND" = true ] ; then
472 if [ "$ENABLE_SOUND" = true ] ; then
471 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
473 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
472 fi
474 fi
473
475
474 # Add rng-tools package
476 # Add rng-tools package
475 if [ "$ENABLE_HWRANDOM" = true ] ; then
477 if [ "$ENABLE_HWRANDOM" = true ] ; then
476 APT_INCLUDES="${APT_INCLUDES},rng-tools"
478 APT_INCLUDES="${APT_INCLUDES},rng-tools"
477 fi
479 fi
478
480
479 # Add fbturbo video driver
481 # Add fbturbo video driver
480 if [ "$ENABLE_FBTURBO" = true ] ; then
482 if [ "$ENABLE_FBTURBO" = true ] ; then
481 # Enable xorg package dependencies
483 # Enable xorg package dependencies
482 ENABLE_XORG=true
484 ENABLE_XORG=true
483 fi
485 fi
484
486
485 # Add user defined window manager package
487 # Add user defined window manager package
486 if [ -n "$ENABLE_WM" ] ; then
488 if [ -n "$ENABLE_WM" ] ; then
487 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
489 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
488
490
489 # Enable xorg package dependencies
491 # Enable xorg package dependencies
490 ENABLE_XORG=true
492 ENABLE_XORG=true
491 fi
493 fi
492
494
493 # Add xorg package
495 # Add xorg package
494 if [ "$ENABLE_XORG" = true ] ; then
496 if [ "$ENABLE_XORG" = true ] ; then
495 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
497 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
496 fi
498 fi
497
499
498 # Replace selected packages with smaller clones
500 # Replace selected packages with smaller clones
499 if [ "$ENABLE_REDUCE" = true ] ; then
501 if [ "$ENABLE_REDUCE" = true ] ; then
500 # Add levee package instead of vim-tiny
502 # Add levee package instead of vim-tiny
501 if [ "$REDUCE_VIM" = true ] ; then
503 if [ "$REDUCE_VIM" = true ] ; then
502 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
504 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
503 fi
505 fi
504
506
505 # Add dropbear package instead of openssh-server
507 # Add dropbear package instead of openssh-server
506 if [ "$REDUCE_SSHD" = true ] ; then
508 if [ "$REDUCE_SSHD" = true ] ; then
507 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
509 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
508 fi
510 fi
509 fi
511 fi
510
512
511 if [ "$RELEASE" != "jessie" ] ; then
513 if [ "$RELEASE" != "jessie" ] ; then
512 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
514 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
513 fi
515 fi
514
516
515 # Configure kernel sources if no KERNELSRC_DIR
517 # Configure kernel sources if no KERNELSRC_DIR
516 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
518 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
517 KERNELSRC_CONFIG=true
519 KERNELSRC_CONFIG=true
518 fi
520 fi
519
521
520 # Configure reduced kernel
522 # Configure reduced kernel
521 if [ "$KERNEL_REDUCE" = true ] ; then
523 if [ "$KERNEL_REDUCE" = true ] ; then
522 KERNELSRC_CONFIG=false
524 KERNELSRC_CONFIG=false
523 fi
525 fi
524
526
525 # Execute bootstrap scripts
527 # Execute bootstrap scripts
526 for SCRIPT in bootstrap.d/*.sh; do
528 for SCRIPT in bootstrap.d/*.sh; do
527 head -n 3 "$SCRIPT"
529 head -n 3 "$SCRIPT"
528 . "$SCRIPT"
530 . "$SCRIPT"
529 done
531 done
530
532
531 ## Execute custom bootstrap scripts
533 ## Execute custom bootstrap scripts
532 if [ -d "custom.d" ] ; then
534 if [ -d "custom.d" ] ; then
533 for SCRIPT in custom.d/*.sh; do
535 for SCRIPT in custom.d/*.sh; do
534 . "$SCRIPT"
536 . "$SCRIPT"
535 done
537 done
536 fi
538 fi
537
539
538 # Execute custom scripts inside the chroot
540 # Execute custom scripts inside the chroot
539 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
541 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
540 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
542 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
541 chroot_exec /bin/bash -x <<'EOF'
543 chroot_exec /bin/bash -x <<'EOF'
542 for SCRIPT in /chroot_scripts/* ; do
544 for SCRIPT in /chroot_scripts/* ; do
543 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
545 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
544 $SCRIPT
546 $SCRIPT
545 fi
547 fi
546 done
548 done
547 EOF
549 EOF
548 rm -rf "${R}/chroot_scripts"
550 rm -rf "${R}/chroot_scripts"
549 fi
551 fi
550
552
551 # Remove c/c++ build environment from the chroot
553 # Remove c/c++ build environment from the chroot
552 chroot_remove_cc
554 chroot_remove_cc
553
555
554 # Remove apt-utils
556 # Remove apt-utils
555 if [ "$RELEASE" = "jessie" ] ; then
557 if [ "$RELEASE" = "jessie" ] ; then
556 chroot_exec apt-get purge -qq -y --force-yes apt-utils
558 chroot_exec apt-get purge -qq -y --force-yes apt-utils
557 fi
559 fi
558
560
559 # Generate required machine-id
561 # Generate required machine-id
560 MACHINE_ID=$(dbus-uuidgen)
562 MACHINE_ID=$(dbus-uuidgen)
561 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
563 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
562 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
564 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
563
565
564 # APT Cleanup
566 # APT Cleanup
565 chroot_exec apt-get -y clean
567 chroot_exec apt-get -y clean
566 chroot_exec apt-get -y autoclean
568 chroot_exec apt-get -y autoclean
567 chroot_exec apt-get -y autoremove
569 chroot_exec apt-get -y autoremove
568
570
569 # Unmount mounted filesystems
571 # Unmount mounted filesystems
570 umount -l "${R}/proc"
572 umount -l "${R}/proc"
571 umount -l "${R}/sys"
573 umount -l "${R}/sys"
572
574
573 # Clean up directories
575 # Clean up directories
574 rm -rf "${R}/run/*"
576 rm -rf "${R}/run/*"
575 rm -rf "${R}/tmp/*"
577 rm -rf "${R}/tmp/*"
576
578
577 # Clean up files
579 # Clean up files
578 rm -f "${ETC_DIR}/ssh/ssh_host_*"
580 rm -f "${ETC_DIR}/ssh/ssh_host_*"
579 rm -f "${ETC_DIR}/dropbear/dropbear_*"
581 rm -f "${ETC_DIR}/dropbear/dropbear_*"
580 rm -f "${ETC_DIR}/apt/sources.list.save"
582 rm -f "${ETC_DIR}/apt/sources.list.save"
581 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
583 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
582 rm -f "${ETC_DIR}/*-"
584 rm -f "${ETC_DIR}/*-"
583 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
585 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
584 rm -f "${ETC_DIR}/resolv.conf"
586 rm -f "${ETC_DIR}/resolv.conf"
585 rm -f "${R}/root/.bash_history"
587 rm -f "${R}/root/.bash_history"
586 rm -f "${R}/var/lib/urandom/random-seed"
588 rm -f "${R}/var/lib/urandom/random-seed"
587 rm -f "${R}/initrd.img"
589 rm -f "${R}/initrd.img"
588 rm -f "${R}/vmlinuz"
590 rm -f "${R}/vmlinuz"
589 rm -f "${R}${QEMU_BINARY}"
591 rm -f "${R}${QEMU_BINARY}"
590
592
591 if [ "$ENABLE_QEMU" = true ] ; then
593 if [ "$ENABLE_QEMU" = true ] ; then
592 # Configure qemu compatible kernel
594 # Configure qemu compatible kernel
593 DTB_FILE=vexpress-v2p-ca15_a7.dtb
595 DTB_FILE=vexpress-v2p-ca15_a7.dtb
594 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
596 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
595 KERNEL_DEFCONFIG="vexpress_defconfig"
597 KERNEL_DEFCONFIG="vexpress_defconfig"
596 if [ "$KERNEL_MENUCONFIG" = false ] ; then
598 if [ "$KERNEL_MENUCONFIG" = false ] ; then
597 KERNEL_OLDDEFCONFIG=true
599 KERNEL_OLDDEFCONFIG=true
598 fi
600 fi
599
601
600 # Setup QEMU directory
602 # Setup QEMU directory
601 mkdir "${BASEDIR}/qemu"
603 mkdir "${BASEDIR}/qemu"
602
604
603 # Copy kernel image to QEMU directory
605 # Copy kernel image to QEMU directory
604 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
606 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
605
607
606 # Copy kernel config to QEMU directory
608 # Copy kernel config to QEMU directory
607 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
609 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
608
610
609 # Copy kernel dtbs to QEMU directory
611 # Copy kernel dtbs to QEMU directory
610 for dtb in "${BOOT_DIR}/"*.dtb ; do
612 for dtb in "${BOOT_DIR}/"*.dtb ; do
611 if [ -f "${dtb}" ] ; then
613 if [ -f "${dtb}" ] ; then
612 install_readonly "${dtb}" "${BASEDIR}/qemu/"
614 install_readonly "${dtb}" "${BASEDIR}/qemu/"
613 fi
615 fi
614 done
616 done
615
617
616 # Copy kernel overlays to QEMU directory
618 # Copy kernel overlays to QEMU directory
617 if [ -d "${BOOT_DIR}/overlays" ] ; then
619 if [ -d "${BOOT_DIR}/overlays" ] ; then
618 # Setup overlays dtbs directory
620 # Setup overlays dtbs directory
619 mkdir "${BASEDIR}/qemu/overlays"
621 mkdir "${BASEDIR}/qemu/overlays"
620
622
621 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
623 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
622 if [ -f "${dtb}" ] ; then
624 if [ -f "${dtb}" ] ; then
623 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
625 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
624 fi
626 fi
625 done
627 done
626 fi
628 fi
627
629
628 # Copy u-boot files to QEMU directory
630 # Copy u-boot files to QEMU directory
629 if [ "$ENABLE_UBOOT" = true ] ; then
631 if [ "$ENABLE_UBOOT" = true ] ; then
630 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
632 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
631 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
633 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
632 fi
634 fi
633 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
635 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
634 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
636 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
635 fi
637 fi
636 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
638 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
637 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
639 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
638 fi
640 fi
639 fi
641 fi
640
642
641 # Copy initramfs to QEMU directory
643 # Copy initramfs to QEMU directory
642 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
644 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
643 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
645 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
644 fi
646 fi
645 fi
647 fi
646
648
647 # Calculate size of the chroot directory in KB
649 # Calculate size of the chroot directory in KB
648 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
650 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
649
651
650 # Calculate the amount of needed 512 Byte sectors
652 # Calculate the amount of needed 512 Byte sectors
651 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
653 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
652 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
654 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
653 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
655 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
654
656
655 # The root partition is EXT4
657 # The root partition is EXT4
656 # This means more space than the actual used space of the chroot is used.
658 # This means more space than the actual used space of the chroot is used.
657 # As overhead for journaling and reserved blocks 35% are added.
659 # As overhead for journaling and reserved blocks 35% are added.
658 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
660 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
659
661
660 # Calculate required image size in 512 Byte sectors
662 # Calculate required image size in 512 Byte sectors
661 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
663 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
662
664
663 # Prepare image file
665 # Prepare image file
664 if [ "$ENABLE_SPLITFS" = true ] ; then
666 if [ "$ENABLE_SPLITFS" = true ] ; then
665 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
667 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
666 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
668 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
667 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
669 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
668 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
670 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
669
671
670 # Write firmware/boot partition tables
672 # Write firmware/boot partition tables
671 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
673 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
672 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
674 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
673 EOM
675 EOM
674
676
675 # Write root partition table
677 # Write root partition table
676 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
678 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
677 ${TABLE_SECTORS},${ROOT_SECTORS},83
679 ${TABLE_SECTORS},${ROOT_SECTORS},83
678 EOM
680 EOM
679
681
680 # Setup temporary loop devices
682 # Setup temporary loop devices
681 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
683 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
682 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
684 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
683 else # ENABLE_SPLITFS=false
685 else # ENABLE_SPLITFS=false
684 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
686 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
685 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
687 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
686
688
687 # Write partition table
689 # Write partition table
688 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
690 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
689 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
691 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
690 ${ROOT_OFFSET},${ROOT_SECTORS},83
692 ${ROOT_OFFSET},${ROOT_SECTORS},83
691 EOM
693 EOM
692
694
693 # Setup temporary loop devices
695 # Setup temporary loop devices
694 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
696 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
695 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
697 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
696 fi
698 fi
697
699
698 if [ "$ENABLE_CRYPTFS" = true ] ; then
700 if [ "$ENABLE_CRYPTFS" = true ] ; then
699 # Create dummy ext4 fs
701 # Create dummy ext4 fs
700 mkfs.ext4 "$ROOT_LOOP"
702 mkfs.ext4 "$ROOT_LOOP"
701
703
702 # Setup password keyfile
704 # Setup password keyfile
703 touch .password
705 touch .password
704 chmod 600 .password
706 chmod 600 .password
705 echo -n ${CRYPTFS_PASSWORD} > .password
707 echo -n ${CRYPTFS_PASSWORD} > .password
706
708
707 # Initialize encrypted partition
709 # Initialize encrypted partition
708 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
710 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
709
711
710 # Open encrypted partition and setup mapping
712 # Open encrypted partition and setup mapping
711 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
713 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
712
714
713 # Secure delete password keyfile
715 # Secure delete password keyfile
714 shred -zu .password
716 shred -zu .password
715
717
716 # Update temporary loop device
718 # Update temporary loop device
717 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
719 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
718
720
719 # Wipe encrypted partition (encryption cipher is used for randomness)
721 # Wipe encrypted partition (encryption cipher is used for randomness)
720 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
722 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
721 fi
723 fi
722
724
723 # Build filesystems
725 # Build filesystems
724 mkfs.vfat "$FRMW_LOOP"
726 mkfs.vfat "$FRMW_LOOP"
725 mkfs.ext4 "$ROOT_LOOP"
727 mkfs.ext4 "$ROOT_LOOP"
726
728
727 # Mount the temporary loop devices
729 # Mount the temporary loop devices
728 mkdir -p "$BUILDDIR/mount"
730 mkdir -p "$BUILDDIR/mount"
729 mount "$ROOT_LOOP" "$BUILDDIR/mount"
731 mount "$ROOT_LOOP" "$BUILDDIR/mount"
730
732
731 mkdir -p "$BUILDDIR/mount/boot/firmware"
733 mkdir -p "$BUILDDIR/mount/boot/firmware"
732 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
734 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
733
735
734 # Copy all files from the chroot to the loop device mount point directory
736 # Copy all files from the chroot to the loop device mount point directory
735 rsync -a "${R}/" "$BUILDDIR/mount/"
737 rsync -a "${R}/" "$BUILDDIR/mount/"
736
738
737 # Unmount all temporary loop devices and mount points
739 # Unmount all temporary loop devices and mount points
738 cleanup
740 cleanup
739
741
740 # Create block map file(s) of image(s)
742 # Create block map file(s) of image(s)
741 if [ "$ENABLE_SPLITFS" = true ] ; then
743 if [ "$ENABLE_SPLITFS" = true ] ; then
742 # Create block map files for "bmaptool"
744 # Create block map files for "bmaptool"
743 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
745 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
744 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
746 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
745
747
746 # Image was successfully created
748 # Image was successfully created
747 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
749 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
748 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
750 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
749 else
751 else
750 # Create block map file for "bmaptool"
752 # Create block map file for "bmaptool"
751 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
753 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
752
754
753 # Image was successfully created
755 # Image was successfully created
754 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
756 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
755
757
756 # Create qemu qcow2 image
758 # Create qemu qcow2 image
757 if [ "$ENABLE_QEMU" = true ] ; then
759 if [ "$ENABLE_QEMU" = true ] ; then
758 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
760 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
759 QEMU_SIZE=16G
761 QEMU_SIZE=16G
760
762
761 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
763 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
762 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
764 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
763
765
764 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
766 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
765 fi
767 fi
766 fi
768 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant